S98

# file containing full e-mail addresses of spammers (for check_mail):
# spammer@address.domain "Error-Code Error-Text"
# spammer@address.domain SPAMMER
# or junk domains (for check_mail, check_relay):
# junk.domain  "Error-Code Error-Text"
# junk.domain  JUNK
# or IP addresses (for check_relay):
# D.X.Y.Z "Error-Code Error-Text"
# C.X.Y "Error-Code Error-Text"
# B.X "Error-Code Error-Text"
# A "Error-Code Error-Text"
Kjunk hash -a@JUNK /etc/mail/deny


# file containing IP numbers of machines which can use our relay
F{LocalIP} /etc/mail/ip_allow

# file containing names of machines which can use our relay
F{LocalNames} /etc/mail/name_allow


# file containing names we relay to
F{RelayTo} /etc/mail/relay_allow
# addresses sent to foo@host.REDIRECT will give a 551 error code
R$* < @ $+ .REDIRECT. >		$: $1 < @ $2 . REDIRECT . > < ${opMode} >
R$* < @ $+ .REDIRECT. > <i>	$: $1 < @ $2 . REDIRECT. >
R$* < @ $+ .REDIRECT. > < $- >	$# error $@ 5.1.1 $: "551 User has moved; please try " <$1@$2>



# check for junk domain/spammers
Sjunk
# lookup domain in database
R$*<@$+>		$:$1<@$(junk $2$)>
# exists? return
R$*<@JUNK@JUNK>		$@$1<@ "501 This domain is banned, contact your local admin." @JUNK>
R$*<@$*@JUNK>		$@$1<@$2@JUNK>
# lookup address in database
R$*<@$+>		$:$1<@$(junk $1@$2 $:$2$)>
# exists? return
R$*<@SPAMMER@JUNK>	$@$1<@ "501 You are banned, contact your local admin." @JUNK>
R$*<@$*@JUNK>		$@$1<@$2@JUNK>
# remove one subdomain, try again
R$*<@$-.$-.$+>		$: $>junk $1<@$3.$4>



Scheck_mail
# don't check these
R<$*@$=w>	$@ ok                   shortcut
# must accept <>
R<>		$@ OK
# remove at least the dot...
R$*@$*.		$1@$2
R<$*@$*.>	<$1@$2>
R$*		$: $>3 $1                       canonify
R$-		$@ ok
# no host without a . in the FQHN ?
R$*<@$->$*	$#error $@ 5.1.8 $: "501 invalid host name " $2 ", check your configuration."
# lookup IP address (reverse mapping available?)
#R$*<@[$-.$-.$-.$-]>$*	$: $1 < @ $[ [ $2.$3.$4.$5 ] $] > $6
# copy the result of the lookup
R$*			$:$1 $| $1
# now remove the dot
R$* $| $*<@$*.>$*	$: $1 $| $2<@$3>$4
# and check the database
R$* $| $*<@$*>$*	$: $1 $| $>junk $2<@$3>
# match: return given error code (rhs of map)
R$* $| $*<@$*@JUNK>$*	$#error $@ 5.7.1 $: $3
# restore original value (after canonicalization by ruleset 3)
R$* $| $*		$: $1
# this is dangerous! no real name
# (see RFC 1123, sections 5.2.2 and 5.2.18)
R$*<@$*$~P>$*	$#error $@ 4.1.8 $: "451 unresolvable host name " $2$3 ", see RFC 1123, sections 5.2.2 and 5.2.18."



Scheck_rcpt
# first: get client address
R$+			$: $(dequote "" $&{client_addr} $) $| $1
R0 $| $*		$@ OK           client_addr is 0 for sendmail -bs
R$={LocalIP}$* $| $*	$@ OK           from here
# next: get client name
R$* $| $+		$: $(dequote "" $&{client_name} $) $| $2
R $| $*			$@ OK           no client name: directly invoked
#R$- $| $*		$@ OK           for those without full DNS...
R$*$=w $| $*		$@ OK           from here
R$*$={LocalNames} $| $*	$@ OK           from allowed system
# now check other side
R$* $| $*		$: $>3 $2
# remove local part
R$+			$:$>remove_local $1
# still something left?
R$*<@$+>$*		$#error $@ 5.7.1 $: 550 we do not relay $&f

Sremove_local
# remove local part (maybe repeatedly)
R$*<@$*$={RelayTo}.>$*	$>3 $1 $4
R$*<@$=w.>$*		$: $>remove_local $>3 $1 $3
R$*<@$*>$*		$@ $1<@$2>$3
# dequote local part
R$-			$: $>3 $(dequote $1 $)
R$*<@$*>$*		$: $>remove_local $1<@$2>$3



SjunkIP
# lookup IP in database
# full IP address
R$-.$-.$-.$-	$: $(junk $1.$2.$3.$4 $)
# class C net
R$-.$-.$-.$-	$: $(junk $1.$2.$3 $: $1.$2.$3.$4 $)
# class B net
R$-.$-.$-.$-	$: $(junk $1.$2 $: $1.$2.$3.$4 $)
# class A net
R$-.$-.$-.$-	$: $(junk $1 $: $1.$2.$3.$4 $)

Scheck_relay
# check IP
R$+ $| $+		$: $1 $| $>junkIP $2
R$+ $| JUNK@JUNK	$#error $@ 5.7.1 $: "550 access from your IP address denied."
R$+ $| $*@JUNK		$#error $@ 5.7.1 $: $2
# check hostname
R$+ $| $+		$: $>junk <@$1>
R$*<@JUNK@JUNK>$*	$#error $@ 5.7.1 $: "550 access from your hostname denied."
R$*<@$*@JUNK>$*		$#error $@ 5.7.1 $: $2
